<!--

// QTVR Properties v0.2  By Eric Gerds   http://www.pinlady.net/vr
// This code will display the current pan,tilt,fov of a QTVR movie

var G = new Object();

// Defaults
G.srcdefault = 'pano.mov';
G.widthdefault = '100%';
G.heightdefault = '100%';
G.controldefault = false;
G.cachedefault = true;
G.scaledefault = 'tofit';
G.kioskdefault = true;
G.bgcolordefault = '#000000';
G.fullscreendefault = true;


// Initialize the embed/object tag parameters for the QTVR
function initall(){
document.getElementById("width").value = G.widthdefault;
document.getElementById("height").value = G.heightdefault;
document.getElementById("controller").checked = G.controldefault;
document.getElementById("bgcolor").value = G.bgcolordefault;
document.getElementById("cache").checked = G.cachedefault;
document.getElementById("scale").value = G.scaledefault;
document.getElementById("kiosk").checked = G.kioskdefault;
document.getElementById("fullscreen").checked = G.fullscreendefault;

// We cannot initialize this field due to security reasons
// document.getElementById("src").value = G.srcdefault;

// Get the current directory
var baseRef = location.href.substring(0,location.href.lastIndexOf("/") + 1);

}


// Print out misc stuff about the QTVR
function miscstuff(){
//a = document.getElementById("misc")
//for (x in a){
//    tmp = eval("a."+x);alert(x + " = " + tmp)        	}


var QTversion =  getprop(G.win.document,'GetQuickTimeVersion()');
var numtracks =  getprop(G.win.document,'GetTrackCount()');
var tracks=""
for (var x=1;x<=numtracks;x++){
 tracks+="<br>&nbsp;&nbsp;&nbsp;&nbsp;Track " + x + ": " +
   getprop(G.win.document,'GetTrackName()',x) + "&nbsp;&nbsp;&nbsp;" +
   getprop(G.win.document,'GetTrackType()',x);
 }


var tmp;
var userdata="";
tmp = getprop(G.win.document,'GetUserData(\'nam\')');
if (tmp!=""){userdata+="<br>" + tmp};

tmp = getprop(G.win.document,'GetUserData(\'cpy\')');
if (tmp!=""){userdata+="<br>" + tmp};

tmp = getprop(G.win.document,'GetUserData(\'day\')');
if (tmp!=""){userdata+="<br>" + tmp};

tmp = getprop(G.win.document,'GetUserData(\'dir\')');
if (tmp!=""){userdata+="<br>" + tmp};

tmp = getprop(G.win.document,'GetUserData(\'fmt\')');
if (tmp!=""){userdata+="<br>" + tmp};

tmp = getprop(G.win.document,'GetUserData(\'inf\')');
if (tmp!=""){userdata+="<br>" + tmp};

tmp = getprop(G.win.document,'GetUserData(\'prd\')');
if (tmp!=""){userdata+="<br>" + tmp};

tmp = getprop(G.win.document,'GetUserData(\'src\')');
if (tmp!=""){userdata+="<br>" + tmp};

tmp = getprop(G.win.document,'GetUserData(\'wrt\')');
if (tmp!=""){userdata+="<br>" + tmp};




document.getElementById("misc").innerHTML = 
  "<br>QuickTime Version: " + QTversion +
  "<br># QuickTime Tracks: " + numtracks + tracks +
  userdata;

}



// Open a new web page with the QTVR
function openwin(){
t = document.getElementById("fullscreen").checked;

var wf =  "resizable=yes";
wf = wf + ",scrollbars=no";
wf = wf + ",menubar=no";
wf = wf + ",toolbar=no";
wf = wf + ",directories=no";
wf = wf + ",location=no";
wf = wf + ",status=no";

if (!t){wf=''};

// We specify a target window of testqtvrpano, so that
// only one pano window can be open at any given time.
if (!G.win || G.win.closed){
G.win = window.open('','testqtvrpano',wf);
}

// Get the current directory
var baseRef = location.href.substring(0,location.href.lastIndexOf("/") + 1);

var width = document.getElementById("width").value;
var height = document.getElementById("height").value;
var controller =  document.getElementById("controller").checked;
var bgcolor = document.getElementById("bgcolor").value;
var cache = document.getElementById("cache").checked;
var scale = document.getElementById("scale").value;
var kiosk = document.getElementById("kiosk").checked;
var src = document.getElementById("src").value;

// Get src qtvr movie.
// We must decide whether the movie is local or on the internet.
// Local would be file:///C:/stuff/mypano.mov
// Internet would be http://www.mywebsite.com/stuff/pano.mov
if (src==null || src==""){src = baseRef + G.srcdefault};

// If src does not specify file: or http: then we assume it is
// local and add file:/// to the beginning
if (src.indexOf("file://")==-1 && src.indexOf("http://")==-1){
    src = "file:///" + src };                                                      

makeqtvrpage(width,height,src,
  controller,cache,scale,bgcolor,kiosk);

if (G.win && !G.win.closed){G.win.focus()};

}




// Return the .comm property/method value for the embed tag (id = vieweremb)
// or the object tag (id = viewerobj).
// Else return NULL if property not found.
//
// It is assumed here that comm will actually return a value.
// comm can be of the form: 'PropertyName' or 'MethodName()'
// comm and arg are strings.
//
// arg is optional.
// If arg is supplied, then this means we have a method : comm(arg)
//
// Example: for method BlaBla(5) we could have comm='BlaBla(5)'
//  OR comm='BlaBla()' & arg='5'
// For method BlaBla("5") we would have comm='BlaBla(\'5\')'
//  OR comm='BlaBla()' & arg='\'5\''
//
// Note: QT 5 cannot use Javascript with IE, but QT6 can. Also, not
// all browsers may allow browser javascipt to QT interaction.
function getprop(win,comm,arg){
var a="",e;

if (arg) {
  comm = comm.replace(/\)$/,""); // Get rid of ) at end of comm string
  comm += arg + ")"              // insert arg
}


// If .comm property does not exist, then try the viewerobj tag instead.
// If it does exist, but its VALUE is undefined, then try the viewerobj tag.
if (typeof win.getElementById("viewerobj") != "undefined"){
  try{
    eval("a = win.getElementById(\"viewerobj\")." + comm);
    if (typeof a != "undefined"){return a};
             }
  catch(e){};
    }


if (typeof win.getElementById("vieweremb") != "undefined"){
  try{
    eval("a = win.getElementById(\"vieweremb\")." + comm);
    if (typeof a != "undefined"){return a};
             }
  catch(e){};
    }

return(null); // Return null if .comm property/method does not exist,
              // OR if it exists but has undefined value.
}

// I create a separate setprop function, because combining
// setprop and getprop into one function is maybe not so good.
// A function can perform a method, yet not return any value,
// hence this separate function.
// comm and arg are strings.
// Return true if successful, false otherwise.
//
// win is a reference to the window
function runprop(win,comm,arg){
if (arg) {
  comm = comm.replace(/\)$/,"");
  comm += arg + ")"
}

//alert(comm)
if (typeof win.getElementById("viewerobj") != "undefined"){
  try{
    eval("win.getElementById(\"viewerobj\")." + comm);
    return true;
             }
  catch(e){};
    }


if (typeof win.getElementById("vieweremb") != "undefined"){
  try{
    eval("win.getElementById(\"vieweremb\")." + comm);
    return true;
             }
  catch(e){};
    }

return false;
}

function setprop(win,comm,val){
if (typeof win.getElementById("viewerobj") != "undefined"){
  try{
    eval("win.getElementById(\"viewerobj\")." + comm + " = " + val);
    return true;
             }
  catch(e){};
    }

if (typeof win.getElementById("vieweremb") != "undefined"){
  try{
    eval("win.getElementById(\"vieweremb\")." + comm + " = " + val);
    return true;
             }
  catch(e){};
    }

return false;
}

// Set the pan,tilt,fov for QuickTime object
function setptf(){
if (!G.win || G.win.closed){return}
// if (window.opener && !window.opener.closed){}

var pan = document.getElementById("pan").value;
var tilt = document.getElementById("tilt").value;
var fov = document.getElementById("fov").value;
runprop(G.win.document,'SetPanAngle()',pan);
runprop(G.win.document,'SetTiltAngle()',tilt);
runprop(G.win.document,'SetFieldOfView()',fov);




}

// Reset pan,tilt,fov to their default values
function defview(){
if (!G.win || G.win.closed){return}
runprop(G.win.document,'ShowDefaultView()');

getptf();

}


// Print out pan,tilt,fov for a QuickTime object
function getptf(){
//if (window.opener && !window.opener.closed){}
if (!G.win || G.win.closed){return}

var pan = getprop(G.win.document,'GetPanAngle()');
var tilt = getprop(G.win.document,'GetTiltAngle()');
var fov = getprop(G.win.document,'GetFieldOfView()');

if (pan==null || tilt==null || fov==null){return false};

// rect is a string of the form [x1,y1,x2,y2]. It is the rectangle of
// the display window in the browser.
var rect = getprop(G.win.document, 'GetRectangle()');
var c1 = rect.indexOf(",",0), c2 = rect.indexOf(",",c1+1),
  c3 = rect.indexOf(",",c2+1); // Get index of commas
var x1 = rect.substring(0,c1), y1 = rect.substring(c1+1,c2),
  x2 = rect.substring(c2+1,c3), y2 = rect.substring(c3+1,rect.length);

// Convert to numbers. We make sure they are integers.
x1 = parseInt(x1,10); y1 = parseInt(y1,10);
x2 = parseInt(x2,10); y2 = parseInt(y2,10);



// Calculate the horizontal fov suing the display window size and the
// vertical fov of the QTVR movie.
var displaywidth = x2 - x1,
    displayheight = y2 - y1,
    fovrad = fov * Math.PI/180; // convert from degrees to radians


var hfov = (180/Math.PI)*2*Math.atan(displaywidth*(Math.tan(fovrad/2))/displayheight);


var m = 1000;
pan = Math.round(pan*m)/m;
tilt = Math.round(tilt*m)/m;
fov = Math.round(fov*m)/m;
hfov = Math.round(hfov*m)/m;

document.getElementById("pan").value =   pan;
document.getElementById("tilt").value =  tilt;
document.getElementById("fov").value =   fov;
document.getElementById("hfov").value =   hfov;


miscstuff();
// allprops()

}

// List all properties for viewerobj and vieweremb
function allprops(){
var a="";
var b="";
var c;

if (G.win.document.getElementById("viewerobj")){
   a+="OBJECT Tag properties: <br>";
   pL = new Array();
   for (property in G.win.document.getElementById("viewerobj")){
     pL[pL.length] = String(property)};

   for (i=0;i<pL.length;i++){

try{
   eval("c = G.win.document.getElementById(\"viewerobj\")." + pL[i] +"()");
}
catch(e){eval("c = G.win.document.getElementById(\"viewerobj\")." + pL[i])};

//   a+=pL[i] +"="+c+", ";
a+=pL[i] + ", ";
       }

}


if (G.win.document.getElementById("vieweremb")){
 b+="<br><br><br>EMBED Tag properties: <br>";

   pL1 = new Array();
   for (property in G.win.document.getElementById("vieweremb")){
     pL1[pL1.length] = String(property)};

   for (i=0;i<pL1.length;i++){
try{
   eval("c = G.win.document.getElementById(\"vieweremb\")." + pL1[i]+"()");
}
catch(e){eval("c = G.win.document.getElementById(\"vieweremb\")." + pL1[i])};

//   b+=pL1[i]+"="+c+", ";
b+=pL1[i]+", ";
       }
}

qqq = window.open();

qqq.document.open();
//qqq.document.write(a);
qqq.document.write(a+b);
qqq.document.close();

}


// Get width and height of QTVR movie display
function getwidthheight(){
var width = getprop(document,'width');
var height = getprop(document, 'height');

document.getElementById("width").value =  width;
document.getElementById("height").value = height;

}

// Put HTML code into the G.win window
function makeqtvrpage(width,height,src,controller,cache,
    scale,bgcolor,kioskmode){
var a = unescape(src);
a = a.substring(a.indexOf(":")+1,a.length);
if (a.substring(0,1)=="/"){a = a.substring(1,a.length)};
if (a.substring(0,1)=="/"){a = a.substring(1,a.length)};
if (a.substring(0,1)=="/"){a = a.substring(1,a.length)};
if (a.substring(0,1)=="/"){a = a.substring(1,a.length)};

var yy = "<html><head>"+
"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=us-ascii\">"+
"<title>" + a + "</title>"+
"</head>" +
"<body BGCOLOR=\"#FFFFFF\">" +
"<div align=\"center\">";

var xx = "<object classid=\"clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B\" " +
  "width=\"" + width + "\" height=\"" + height + "\" id=\"viewerobj\" " +
  "codebase=\"http://www.apple.com/qtactivex/qtplugin.cab\">" +
  "<param name=\"src\" value=\""+src+"\">" +
  "<param name =\"controller\" value=\"" + controller + "\">" +
  "<param name =\"cache\" value=\"" + cache +"\">" +
  "<param name =\"scale\" value=\"" + scale + "\">" +
  "<param name =\"bgcolor\" value=\"" + bgcolor + "\">" +
  "<param name =\"kioskmode\" value=\"" + kioskmode + "\">" +
  "<param name=\"enablejavascript\" value=\"true\">" +

  "<embed src=\"" + src + "\" id=\"vieweremb\" " +
  "type=\"video/quicktime\" scale=\"" + scale + "\" " +
  "pluginspage=\"http://www.apple.com/quicktime/download/\" " +
  "width=\"" + width + "\" height=\"" + height + "\" " +
  "bgcolor=\"" + bgcolor + "\" controller=\"" + controller + "\" " +
  "enablejavascript=\"true\"></EMBED></OBJECT>";

var zz = "</div></body></html>";

//alert(yy+xx+zz)
G.win.document.open();
G.win.document.write(yy+xx+zz);
G.win.document.close();
}

// -->
